;11/06/2004 : Fixed a memory release bug in the dll source.

;-------------------------------------------------------------------------
;Example on how to use the qhull1.dll
;qhull1.dll is a modified and simplified version of qhull1.0
;By Tsiantas Elias 20 feb 2004.
;Full modified source is provided.
;-------------------------------------------------------------------------


;-------------------------------------------------------------------------
;
;Qhull1.0 is free software and hence this modification falls under
;the same license as qhull1.0.
;It may be obtained via anonymous ftp from geom.umn.edu
;Read the Copying_qhull.rtf for more.
;
;
;                     Copyright (c) 1993
;       The National Science And Technology Research Center For
;	     Computation And Visualization of Geometric Structures
;
;-------------------------------------------------------------------------



;-------------------------------------------------------------------------
;In other words this means you are free to modify,redistribute
;and include this dll in your projects but you must include also
;the copyright notice from the Copying_qhull.rtf file.
;-------------------------------------------------------------------------


;YOU NEED THIS DECLS FILE

;.lib "qhull1.dll"
;qhull%(infile$,outfile$,delta#,pf%,fo%):"qh@20"



Include "make_hull.bb"




Graphics3D 640,480,0,2
cam=CreateCamera()
li=CreateLight(2)
LightColor li,30,30,30
PositionEntity li,-50,50,-50
CameraRange cam,1,20000
PositionEntity cam,0,0,-110

m=LoadMesh("ship.3DS")




;-------------------------------------------------------------------------
;THIS IS THE MAIN FUNCTION.
;1. Specify the model.
;2. You must specify 2 file names
;   for example here the in.txt file is the file that the function
;   will produce and send it to qhull1.dll
;   out.off is the file that the dll will return.
;   This file then will be parsed back in the function
;   and the hull mesh will be produced and returned.
;   These are temporary files and get deleted by the function.
;
;3. The 4th parameter is the convex hull aproximation. The higher you set it
;   the lower polygons will be used to create the hull.
;
;4. The 5th parameter indicates if you want to weld the hull or not [0/1] 
;-------------------------------------------------------------------------



r=make_hull( m, "in.txt", "out.off",  0.00, 1)


EntityParent r,m
EntityAlpha r,.5
EntityFX r,16
EntityShininess r,1
EntityColor r,255,255,0


su=GetSurface(r,1)
vt=CountTriangles(su)
vr=CountVertices(su)

While Not KeyHit(1)

RenderWorld
TurnEntity m,0,.2,0
Text 10,0,"Hull vertices: "+vr
Text 10,10,"Hull triangles: "+vt

Text 10,40,dt
If KeyHit (17)
wire=1-wire
WireFrame wire
EntityAlpha m,1-wire
EndIf

Flip
Wend
End